// $Id: ShooterAIWidget.C,v 1.1 2006/08/10 19:47:06 nicholas Exp $

// This is an ORTS file (c) Tim Furtak, licensed under the GPL

#include "ShooterAIWidget.H"
#include "GfxGlobal.H"
#include "GfxModule.H"

using namespace std;

const sint4 line_height = 16;
const sint4 start_off_y = -14;
const real4 size = 7; // +/- size
const sint4 indent = 14;

//===================================================================

ShooterAIWidget::ShooterAIWidget()
{
  set_name("ShooterAI");
}

//===================================================================

void ShooterAIWidget::attach(ShooterAI *ai)
{
  shooter_ai = ai;
}

//===================================================================

stype ShooterAIWidget::event_key_down(stype key, stype /*mod*/, stype x, stype y)
{
  if (!shooter_ai) return stype();
  if (is_outside(x,y)) return stype();

  if (key.to_int() == '\t') {

    bool en = shooter_ai->is_enabled();
    if (!en) {
      shooter_ai->enable();
    } else {
      shooter_ai->disable();
    }
    return stype(1);
  }
  return stype();
}

//===================================================================

stype ShooterAIWidget::event_mouse_down(stype /*mx*/, stype /*my*/, stype /*mb*/)
{
  return stype();
}

//===================================================================

stype ShooterAIWidget::draw()
{
  glDisable(GL_TEXTURE_2D);

  sint4 X = x.to_int();
  sint4 Y = y.to_int();
  sint4 W = w.to_int();
  sint4 H = h.to_int();

  // black background
  glColor4f(0, 0, 0, 0.5);
  glBegin(GL_QUADS);
  glVertex2f(X,   Y);
  glVertex2f(X+W, Y);
  glVertex2f(X+W, Y+H);
  glVertex2f(X,   Y+H);
  glEnd();

  glEnable(GL_SCISSOR_TEST);
  glScissor(X, Y, W, H);

  sint4 start_x = X + 10;
  sint4 start_y = Y + H + start_off_y;

  glColor3f(1, 1, 1);

  string cur_state;
  if (shooter_ai) {
    if (shooter_ai->is_enabled()) {
      cur_state = "enabled";
    } else {
      cur_state = "disabled";
    }
  } else {
    cur_state = "not attached";
  }

  render_bitmap_string(start_x, start_y, GLUT_BITMAP_8_BY_13, cur_state.c_str());

  start_y -= line_height;

  glEnable(GL_TEXTURE_2D);
  glDisable(GL_SCISSOR_TEST);

  return stype();
}

//===================================================================

