#ifndef GAISquad_H
#define GAISquad_H

#include "GAITank.H"
#include "Formations.H"

class GAISquad
{
  public:
	GAISquad(int tanks, bool left);
	void addTank(GAITank* tankje);
	bool actPerTank(const Game& game);
	bool act(const Game& game);
	ScalarPoint getTileCoor(int x, int y);
	ScalarPoint getTileCoor(ScalarPoint x);
	double getAngle(ScalarPoint p1, ScalarPoint p2);
	ScalarPoint myBaseCenter;
	void setWalkabilityBackupTile(int x, int y, int value);

  private:
	bool rangeerTerreinReleased;
	char myWalkability[64][64];
	char WalkabilityBackup[64][64];
	ScalarPoint prevPosition[5];
	ScalarPoint currPosition[5];
	int prevPositionCnt;
	int index;
	int beurt;
	int halfBaseSize;
	ScalarPoint snakeHistory[5];
	GAITank** squad_tanks;
	GameObj** oppBases;
	int tanks, centerTank;
	bool firstTime, squad_formed;
	bool up, down, right, left;
	int horizontal, vertical;
	bool goAheadFormSquad;
	ScalarPoint currentPosition;
	ScalarPoint startXY;
	ScalarPoint goal;
	int closestOppBase;
	ScalarPoint closestOppBaseD;
	aStarLibrary* pathfinder;
	int TileWalkable(const GameTile &tile);
	bool inField(int x, int y);
	ScalarPoint RotateFormation(ScalarPoint p, double angle);
	void setWalkability();
	void resetWalkability();
	double rotation;
	bool doOnce, doTwice;
	void formFormation();
	void snakeWalk();
};

#endif
