#ifndef BUILDTASKS_H
#define BUILDTASKS_H

// $Id: BuildTasks.h,v 1.1 2006/08/10 17:22:31 nicholas Exp $

#include "BTask.h"

#define DECLARE_BTASK(name)						\
  class name : public Task{						\
  public:								\
    name(uint4 playerID,BuildTasksState* state,ObjectVector& origObjects,	\
	 TaskCreateFunctionPtr f,std::string name,real8 timeout,MoveStruct* extraData = NULL); \
    name(Task* parent,ObjectVector& origObjects,TaskCreateFunctionPtr function,std::string name, \
	 real8 timeout, MoveStruct* extraData = NULL); \
    name(const name&);							\
    Task* clone(BuildTasksState* state, Task* parent);			\
    bool exec();							\
  }

namespace BSimul {
  class BuildTasksState;

  DECLARE_BTASK(BuildandTrain);

  // internal tasks, don't use these explicitly right now
  DECLARE_BTASK(MovetoBuild);
  DECLARE_BTASK(BuildControlCenter);
  DECLARE_BTASK(BuildBarracks);
  DECLARE_BTASK(BuildFactory);
  DECLARE_BTASK(TrainMarine);
  DECLARE_BTASK(TrainTank);
  DECLARE_BTASK(TrainWorker);
  DECLARE_BTASK(Scout);
  //DECLARE_BTASK(Harass);
  DECLARE_BTASK(Save);
  DECLARE_BTASK(RunHome);
  DECLARE_BTASK(MassAttack);


  //Task* createAttackAndDefend(uint4 id, BuildTasksState* s, ObjectVector& o,real8 timeout);
  Task* createBuildandTrain(uint4 id, BuildTasksState* s, ObjectVector& o, real8 timeout);
  //Task* createHarass(uint4 id, BuildTasksState* s, ObjectVector& o, real8 timeout);
  Task* createTrainMarine(uint4 id, BuildTasksState* s, ObjectVector& o, real8 timeout);
  Task* createTrainTank(uint4 id, BuildTasksState* s, ObjectVector& o, real8 timeout);
  Task* createTrainWorker(uint4 id, BuildTasksState* s, ObjectVector& o, real8 timeout);

  Task* createScout(uint4 id, BuildTasksState* s, ObjectVector& o, real8 timeout);
  Task* createMassAttack(uint4 id, BuildTasksState* s, ObjectVector& o, real8 timeout);

  // NOTE: maybe make these available to be made explicitly instead of just being made by the above tasks, not now though
  /*
    Task* createJoin();
    Task* createAttack();
    Task* createMove();
  */

  // FIXME any better way to do this?  a dynamic size?
/*
  const uint4 NUM_STRATEGIES = 6;
  const TaskCreateFunctionPtr strategyList[] = {
    NULL,
    createJoinDefenceNearest,
    createMassAttack_baseFirst,
    createMassAttack_unitsFirst,
    createSpreadAttack_baseFirst,
    createSpreadAttack_unitsFirst
  };
*/
}
#endif

