#ifndef ScriptObjSet_H
#define ScriptObjSet_H

/** @file ScriptObjSet.H

    $Id: ScriptObjSet.H,v 1.1 2006/07/25 17:45:52 orts_furtak Exp $
    $Source: /usr/bodo1/cvs/cvs/orts3/libs/gfxclient/src/ScriptObjSet.H,v $
*/

// This is an ORTS file (c) Tim Furtak

#include "Global.H"
#include "ScriptSet.H"

class PlayerInfo;
class SActParam;
class GfxModule;

//===================================================================

/** A set of object ids that pseudo-automatically removes ids as they
    become invalid.
*/

class ScriptObjSet : public ScriptSet
{
protected:
  static Vector<ScriptObjSet*> instances;
  void invalidate(ScriptObj *obj);

public:
  static GfxModule *gfxm;

  ScriptObjSet();
  ~ScriptObjSet();
  static ScriptObj* create() { return new ScriptObjSet; }

  std::string bp_name() const { return "ScriptObjSet"; }

  static void invalidate_obj(ScriptObj *obj);

private:

  stype select    (const SActParam&);
  stype select_add(const SActParam&);
  stype deselect  (const SActParam&);

  typedef stype (ScriptObjSet::*myfunc)(const SActParam&);
  void add(const std::string &name, myfunc f, sint4 objs, sint4 p, sint4 p2);
};

#endif
