// $Id: DrawOnTerrain2D.C,v 1.1 2007/03/15 10:37:47 orts_furtak Exp $

// This is an ORTS file (c) Tim Furtak, licensed under the GPL

#include "Global.H"
#include "DrawOnTerrain2D.H"
#include "Map.H"
#include "Game.H"
#include "GameTile.H"

using namespace std;

//===================================================================

DrawOnTerrain2D::DrawOnTerrain2D(GUI *g) : gui(g)
{
}

//-------------------------------------------------------------------

DrawOnTerrain2D::~DrawOnTerrain2D()
{
}

//===================================================================

void DrawOnTerrain2D::start()
{
  if (!gui) return;
  gui->lock();
  gui->display(0, 0, false);
}

//-------------------------------------------------------------------

void DrawOnTerrain2D::end()
{
  if (!gui) return;
  gui->unlock();
}

//===================================================================

void DrawOnTerrain2D::draw_line(real4 x1, real4 y1, real4 x2, real4 y2,
                              const Vec3<real4> &col, real4 /*width*/)
{
  if (!gui || gui->views.size() == 0) return;
  sint4 r = sint4(col.r * 256); if (r > 255) r = 255;
  sint4 g = sint4(col.g * 256); if (g > 255) g = 255;
  sint4 b = sint4(col.b * 256); if (b > 255) b = 255;
  RGB c(r,g,b);
  gui->draw_line(gui->views[0], x1, y1, x2, y2, c);
}

//-------------------------------------------------------------------

void DrawOnTerrain2D::draw_circle(real4 cx, real4 cy, real4 radius,
                                const Vec3<real4> &col, real4 /*width*/)
{
  if (!gui || gui->views.size() == 0) return;
  sint4 r = sint4(col.r * 256); if (r > 255) r = 255;
  sint4 g = sint4(col.g * 256); if (g > 255) g = 255;
  sint4 b = sint4(col.b * 256); if (b > 255) b = 255;
  RGB c(r,g,b);
  gui->draw_circle(gui->views[0], cx, cy, radius, c);
}

//===================================================================

void DrawOnTerrain2D::draw_tile(sint4 /*tx*/, sint4 /*ty*/, const Vec3<real4> &/*col*/)
{
}

//===================================================================

void DrawOnTerrain2D::draw_square(real4 /*x1*/, real4 /*y1*/, real4 /*x2*/, real4 /*y2*/,
                                const Vec3<real4> &/*col*/)
{
}

//===================================================================

