#ifndef TCP_Server_H
#define TCP_Server_H

// $Id: TCP_Server.H,v 1.6 2005/05/19 20:39:28 orts_mburo Exp $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

#include "Global.H"

class IO_Buffer ;

class TCP_Server {

public:
  
  Vector<IO_Buffer*> clients;
  
  TCP_Server(sint4 clev_=5);

  void set_clev(sint4 clev_) { clev = clev_; }
  
  TCPsocket init_listen(sint4 port);
  bool handle_connection();
  void close();

  // called on new connection
  virtual IO_Buffer *new_client(TCPsocket so, sint4 clev) const;

  virtual ~TCP_Server();

protected:

  sint4 clev; // compression level
  bool  terminated;
  TCPsocket server_socket;
};

REGISTER_TYPEOF(69, Vector<IO_Buffer*>::iterator);

#endif
