#include "OgreGfxModuleMegaTile.H"

OgreGfxModuleMegaTile::OgreGfxModuleMegaTile(int strtr, int strtc, int r, int c, float tW, float tH, bool** revealed, bool** visible, Ogre::SceneManager* sceneMgr, bool cast_shadows ){
	
	//---Initializations
	startr= strtr;
	startc= strtc;
	rows= r;
	columns= c;
	tileW= tW;
	tileH= tH;
	bRebuildNeeded= false;
	bCastShadows = cast_shadows;
	mSceneMgr = sceneMgr;
	Ogre::String megaTilesName = (Ogre::String)("battlefieldMap")+ Ogre::StringConverter::toString(startr)+'_'+Ogre::StringConverter::toString(startc);
	megaTileGeometry = mSceneMgr->createStaticGeometry(megaTilesName);
	
	//---If any tiles are currently revealed, we'll need to rebuild soon
	//for(int i = startr; i < startr + rows; i++){
	//	for(int j = startc; j < startc + columns; j++){
	//		if(revealed[i][j]){

	return;
}

void OgreGfxModuleMegaTile::addGeometry(Ogre::Entity* newEnt, float x, float y,  float z, float xscale, float yscale, float zscale, Ogre::Quaternion orientation){
	//---The Geometry must first be destroyed before you can add entities to it
	if(!bRebuildNeeded)
		megaTileGeometry->destroy();
	bRebuildNeeded= true;

	//---Add the new tile to the static mesh geometry
	megaTileGeometry->addEntity(newEnt,Ogre::Vector3(x,y,z), orientation, Ogre::Vector3(xscale, yscale, zscale));
	
	return;
}

//---This function rebuilds this megatile only if necessary
void OgreGfxModuleMegaTile::rebuild(){
	if(bRebuildNeeded){
		megaTileGeometry->setCastShadows(bCastShadows);
		megaTileGeometry->build();
		megaTileGeometry->setCastShadows(bCastShadows);
		bRebuildNeeded = false;
	}
	//otherwise, simply return
}

OgreGfxModuleMegaTile::~OgreGfxModuleMegaTile(){
	if(megaTileGeometry && !megaTileGeometry)
		delete megaTileGeometry;
}
