// $Id: VarTable.H,v 1.1.1.1 2004/10/11 09:09:20 orts_mburo Exp $ 

// (c) Jonathan Yip, licensed under the GPL


#ifndef VarTable_H
#define VarTable_H

#include "Global.H"
#include "Mem.H"

using namespace std;

class VarTable {
public:
  VarTable();
  ~VarTable();

  void add_usable_block();
  void add_func_block();
  void del_func_block();
  void del_usable_block();

  Mem::mem_types find_variable(const string &var_name, sint4& loc,  
			       bool& func_var);
  bool exists_var(const string &var_vame, uint4& loc);

  void set_var_type(const string &var_name, const Mem::mem_types type, 
		    bool func_var);
  void set_obj_var(const string &var_name, const string &obj_name, bool func_var);

  void set_var_param(const string &var_name, const Mem::mem_types type);

  void set_obj_param(const string &var_name, const string &obj_name);

  string get_obj(sint4 loc, bool func_var);

  uint4 get_cur_block();

private:
  typedef map<sint4, string> ObjMap;
  typedef pair<string, Mem::mem_types> VarInfo;

  vector< VarInfo > m_vars;
  ObjMap m_objs;

  vector< VarInfo > m_func_params;
  ObjMap m_func_param_objs;

  vector< VarInfo > m_func_vars;
  ObjMap m_func_objs;

  stack<uint4> m_func_loc;

  bool m_func;
  
  stack< uint4 > m_loc;


  // Fixme: need to add objects here???

};



class FuncTable {
public:
  FuncTable() {}
  ~FuncTable() {}

  void set_func_type(const string &func_name, Mem::mem_types type);
  Mem::mem_types find_function(const string &func_name);

  //  friend class Script;

private:

  map<string, Mem::mem_types> m_funcs;

};


#endif
