
#include "AttractorOverlay.H"
#include "GfxModule.H"
#include "GfxGlobal.H"
#include "Game.H"


//===================================================================
AttractorOverlay::AttractorOverlay(const ForceFieldPE &pe, GfxModule &gfxm_)
  : dot(gfxm_), gfxm(&gfxm_)
{
  enabled = true;
  executor_p = &pe;
}

//-------------------------------------------------------------------

bool AttractorOverlay::handle_event(const Event &e)
{
  if (e.get_who() == GfxModule::FROM) {
    if (e.get_what() == GfxModule::DRAW_MSG) {
      draw();
      return true;
    }
  }
  return false;
}

//-------------------------------------------------------------------

void AttractorOverlay::draw()
{
  if (!enabled) return;


  sint4 tile_points = gfxm->get_game().get_tile_points();

  real4 d = 1.0 / tile_points; //conversion factor between point locations and tile locations
  
  Vec3<real4> c(0,0,1);
  
  dot.begin_lines();
  
  FORALL(executor_p->attractors, it){
    dot.draw_circle(it->x * d, it->y * d, .2, c, 1.0);
  }

  dot.end_lines();
}
