//Threat.cpp

//DJD: functions for ORTS, specifically threat modelling and updates {

#include "Base.h"

//constructor - define the mesh and triangulator to use our faces
TraDcdt::TraDcdt()
{
	_mesh = (SeDcdtMesh *)(new TraMesh);
	_triangulator = new SeTriangulator(SeTriangulator::ModeConstrained, _mesh, new SeDcdtTriManager, 0.000001);
	_first_symedge = 0;
	_cur_search_face = 0;
	_xmin = _xmax = _ymin = _ymax = 0;
	_radius = -1;
	currentPathLength = 0.0f;
}

//updates the enemy influence in a particular triangle,
//and then updates the enemy threat in adjacent triangles
void TraDcdt::UpdateInfluence(TraFace *face, float dUpdate)
{
	if (face->link != NULL)
	{
		face->link->Influence(face->link->Influence() + dUpdate);
	}
	//TODO: update enemy threat model
}

//functions for ORTS, specifically threat modelling and updates }
