#ifndef SI_GROUP_H
#define SI_GROUP_H

// $Id: SI_Group.h,v 1.1 2006/08/10 17:16:01 nicholas Exp $

#include "Global.H"
#include "Vector.H"

#include "SI_Unit.h"

#include "SI_MapObject.h"

#include "SI_SimulationState.h"

namespace Simul{

  const real8 MIN_GROUP_SIZE=0.5;

  class Order;

  typedef Vector<Unit*> UnitVector;

  class Group : public MapObject{
  public:
    Group(uint4 playerID);
    ~Group();
    Group(const Group& b);
    Group* clone() const;

    bool withinRange(Group* otherGroup);

    void recalculateRadius() { this->radius = sqrt((real8)getNumUnits()/M_PI) + MIN_GROUP_SIZE;}

    /*
    void draw();
    void drawInSelectionMode();
  */

    real8 getExtents() const {return radius;}

    uint4 getNumUnits(){return units.size();}

    void setOrder(Order* newOrder);

    Order* getOrder() const {return currentOrder;}
    void executeOrders(real8 timeElapsed);
    void executeOrderAction(SimulationState& state);
    void cleanupOrder();

    real8 getMaxSpeed() const {return maxSpeed;}
    real8 getMaxAttackRange() const {return maxAttackRange;}
    real8 getLastDistanceMoved() const { return lastDistanceMoved;}

    void setUnits(UnitVector u){units = u;}

  private:
    Group& operator=(const Group& b);// {return *b.clone();}; // no = operator for now

    Order* currentOrder;
    real8 maxSpeed;
    real8 maxAttackRange;
    real8 lastDistanceMoved;

    real8 radius;

    UnitVector units;
  };
}

#endif
