/*
    (c) Michael Buro, mic@research.nj.nec.com
    NEC Research Institute
    4 Independence Way
    Princeton, NJ 08540, USA

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "RTS_Options.H"

RTS_Options::RTS_Options()
{
  put("-x",     1024,   "playing field width   [sint4/1024]");
  put("-y",     1024,   "playing field height  [sint4/1024]");
  put("-disp",  true,   "display simulation  [bool/true]");
  put("-track", 0,      "track element with this index  [sint4/0]");
  put("-nmax",  -1,     "max # of elements (<0:inf) [sint4/-1]");
  put("-tmax",  -1,     "max # of ticks (<0:inf) [sint4/-1]");
  put("-save",  false,  "save action history  [bool/false]");
  put("-wait",  0,      "<0:keyboard input, 0:full speed, >0:usleep  [sint4/0]");
  put("-pix",   0,      "pixel size exponent  [sint4/0]");
  put("-sec",   real8(1.25), "sector size factor > 1  [real8/1.25]");
  put("-freq",  real8(0.0), "pl.1 element frequency: 0->1:1, n->n:1, -n->1:n [real8/0]");
  put("-chk",   false,  "call check code  [bool/false]");
  put("-dbg",   false,  "call debug code  [bool/false]");
  put("-seed",  1,      "random number seed (0:use time)  [sint4/1]");
  put("-p1",    string("player1"), "player 1 description file  [string/\"player1\"]");
  put("-p2",    string("player2"), "player 2 description file  [string/\"player2\"]");
  put("-stat",  false,  "display cycle statistics  [bool/false]");
  put("-stop",  true,   "stop when game is finished [bool/true]");
  put("-m",     string("game"),  "mode: game|server|client  [string/\"game\"]");
  put("-type", string("default"), "game type  [string/\"default\"]");
  put("-pnum",  2, "number of players  [sint4/2]");
  put("-speed",  3, "frames/sec  [sint4/3]");
  put("-ggsh",  string("samson"), "ggs host  [string/\"samson\"]");
  put("-ggsp",  5000, "ggs port  [sint4/5000]");
  put("-fow",  false, "fog of war  [bool/false]");  

  put("-cport", 7777,   "client port  [sint4/7777]");
  put("-cpind",  0, "client player index  [sint4/0]");
  put("-cpname",  string("default"), "client player name  [string/\"default\"]");
  put("-cpact", string("std"), "client action name  [string/\"std\"]");
}
