#ifndef SCOUTCOMMANDER_H
#define SCOUTCOMMANDER_H
                                             
#include "TerrainBase.H"
#include "TerrainModule.H"
#include "Watcher.H"
#include "TerrainAnalysis.H"
#include "Commander.H"
#include "ClientModule.H"

class ScoutCommander: public Commander, ClientModule 
{
    /// Identifier of this class when sending events
    static const sint4 FROM; 

    std::set<GameObj*> explorers;
    std::set<GameObj*> recon;
    bool finished;
public: 
    ScoutCommander(Commander * const mySuperior);
    ~ScoutCommander();

    bool isFinished() const;

    void exec();

    /// Get messages about scouts
    void onReceiveUnit(GameObj * unit, Watcher::WatchID);
    void onLoseUnit(GameObj * unit);
    bool onEvent(const Event &);
};

#endif // SCOUTCOMMANDER_H
