#include "ModuleSet.H"
#include <assert.h>
#define NULL 0

ModuleSet::ModuleSet() :
    fm(NULL), gsm(NULL), hm(NULL), scai(NULL), 
    tam(NULL), tb(NULL), tm(NULL), wm(NULL)
{

}

ModuleSet::~ModuleSet()
{

}

void ModuleSet::set_game_state(GameStateModule * gsm)
{
    this->gsm = gsm;
}

void ModuleSet::set_terrain_base(TerrainBase * tb)
{
    this->tb = tb;
}

void ModuleSet::set_terrain(TerrainModule * tm)
{
    this->tm = tm;
}

void ModuleSet::set_combat(SquadCombatAI * scai)
{
    this->scai = scai;
}

void ModuleSet::set_watcher(Watcher::WatcherModule * wm)
{
    this->wm = wm;
}

void ModuleSet::set_history(History::HistoryModule * hm)
{
    this->hm = hm;
}

void ModuleSet::set_terrain_analysis(TerrainAnalysis::Module * tam)
{
    this->tam = tam;
}

void ModuleSet::set_finance(Finance::Module * fm)
{
    this->fm = fm;
}

GameStateModule & ModuleSet::get_game_state() const
{
    assert(gsm != NULL);
    return *gsm;
}

TerrainBase & ModuleSet::get_terrain_base() const
{
    assert(tb != NULL);
    return *tb;
}

TerrainModule & ModuleSet::get_terrain() const
{
    assert(tm != NULL);
    return *tm;
}

SquadCombatAI & ModuleSet::get_combat() const
{
    assert(scai != NULL);
    return *scai;
}

Watcher::WatcherModule & ModuleSet::get_watcher() const
{
    assert(wm != NULL);
    return *wm;
}

History::HistoryModule & ModuleSet::get_history() const
{
    assert(hm != NULL);
    return *hm;
}

TerrainAnalysis::Module & ModuleSet::get_terrain_analysis() const
{
    assert(tam != NULL);
    return *tam;
}

Finance::Module & ModuleSet::get_finance() const
{
    assert(fm != NULL);
    return *fm;
}
