#ifndef __MODULE_SET_H__
#define __MODULE_SET_H__

class GameStateModule;
class TerrainBase;
class TerrainModule;
class SquadCombatAI;
namespace Watcher { class WatcherModule; }
namespace History { class HistoryModule; }
namespace TerrainAnalysis { class Module; }
namespace Finance { class Module; }

class ModuleSet
{
    Finance::Module *         fm;
    GameStateModule *         gsm;
    History::HistoryModule *  hm;
    SquadCombatAI *           scai;
    TerrainAnalysis::Module * tam;
    TerrainBase *             tb;
    TerrainModule *           tm;
    Watcher::WatcherModule *  wm;
public:
    ModuleSet();
    ~ModuleSet();

    void set_game_state(GameStateModule * gsm);
    void set_terrain_base(TerrainBase * tb);
    void set_terrain(TerrainModule * tm);
    void set_combat(SquadCombatAI * scai);
    void set_watcher(Watcher::WatcherModule * wm);
    void set_history(History::HistoryModule * hm);
    void set_terrain_analysis(TerrainAnalysis::Module * tam);
    void set_finance(Finance::Module * fm);

    GameStateModule & get_game_state() const;
    TerrainBase & get_terrain_base() const;
    TerrainModule & get_terrain() const;
    SquadCombatAI & get_combat() const;
    Watcher::WatcherModule & get_watcher() const;
    History::HistoryModule & get_history() const;
    TerrainAnalysis::Module & get_terrain_analysis() const;
    Finance::Module & get_finance() const;
};

#endif
