#include "Commander.H"
#include "Game.H"
#include "SquadCombatAI.H"
#include "Watcher.H"
#include "WatcherAux.H"
#include "ClientModule.H"
#include "TerrainModule.H"
#include "TerrainBase.H"
#include "TerrainClassifier.H"
#include "GameObj.H"
#include "AttackCommander.H"

//currently the defence commander from game3

using namespace Watcher;

   class StrategicCommander: public Commander, ClientModule {
   private:
     sint4 combatEventID;
     sint4 me;
     set<GameObj*> enemies;
     bool receivedNotification;
	 sint4 mode;	
	 GameObj* target;
	 TerrainModule *tm;
     TerrainBase *st;
     GameStateModule *gsm;
	 
   public:  
    StrategicCommander(Commander* const mySuperior, 
                                 Vector<GameObj*> units,
                                 sint4 owner_,
                                 TerrainModule &tm_,
                   				 TerrainBase &st_,
                   				 GameStateModule &gsm_,
                                 sint4 updateTime_=8,
                                 sint4 mode=0):
        Commander(mySuperior, units, updateTime_),
        me(owner_)
       {
       
           /*  combatEventID=myWatcher.notifyOnCondition(this,
                                                     And(InCircle(centre.x, centre.y, radius),
                                                         And(Not(OwnerIs(me)),Not(OwnerIs(2)))),
                                                     TotalCountIs(GREATER_THAN, 0), 8, false);
           receivedNotification=false;
           */
       }
       
	
	TerrainBase::Loc find_a_spot(TerrainBase::Loc center_loc, GameStateModule &gsm);
      
      
       void getGroup(Vector<GameObj*>& closestObjects,
						  Vector<GameObj*> originalObjects,GameObj* obj,uint4 playerID);
						  
	   GameObj* getNearestObject(const Vector<GameObj*>& objects,const TerrainBase::Loc& loc);
       GameObj* getNearestObject(const Vector<GameObj*>& objects,GameObj* obj);
       bool removeObjectFromVector(GameObj* obj, Vector<GameObj*>& vector);
       real8 getNearestEnemyUnitOfGroupDist(uint4 playerID,const Vector<GameObj*>& objects, GameObj* obj);
       
       void exec();
       
       bool handle_event (const Event& event);
       
       Vector<GameObj::WPtr> convertWeakPtrs(vector<GameObj*> vec) {
           Vector<GameObj::WPtr> Wvec;
           FORALL(vec, unit) {
               Wvec.push_back(*unit);
           }
           return Wvec;
       }
       
       void giveUnitNotification() {}
       
       
   };
