#!/bin/bash
if [ -z "$1" ]
then
  echo ' '
  echo 'syntax:'
  echo '  random_tourney.sh <number of games> <out file>'
  echo ' '
  echo 'example:'
  echo '  random_tourney.sh 10 tourney.log'
  echo ' '
  exit
fi

NUM_GAMES=$1
RESULTS=$2

mv $RESULTS $RESULTS.old
echo "---" 1> $RESULTS
echo "Start Time: " 1>> $RESULTS
date 1>> $RESULTS
echo "---" 1>> $RESULTS
echo "Tourney results:" 1>> $RESULTS
echo "---" 1>> $RESULTS

for i in 1 2 4 8 16
do
    player1="-ai randsim -rmdist 6 -mcsteps 18 -mcruns $i -rmruns $i"
    player2="-ai randsim -rmdist 6 -mcsteps 18 -mcruns $i -rmruns $i"
    echo ---------------------------------------------------------------------
    echo Running match:
    echo ... "$player1" 
    echo ... vs.
    echo ... "$player2"
    echo ---------------------------------------------------------------------
    ./run_match.sh $NUM_GAMES "$player1" "$player2" 1>> $RESULTS
done

echo "---" 1>> $RESULTS
echo "End Time: " 1>> $RESULTS
echo "---" 1>> $RESULTS
date 1>> $RESULTS
cat $RESULTS
